*	Include file opcom
*	OPTRANS Common block for variables that need to be saved for other uses.
	
*	Interim results for the star'ed predictors in pressure space
	Real s1(MaxLevel,3),s2(MaxLevel,3),s3(MaxLevel,3)
	Real s4(MaxLevel,3),s5(MaxLevel,3),s6(MaxLevel,3)

*	Star'ed predictors in pressure space	
	Real xx1(MaxLevel,3),xx2(MaxLevel,3),xx3(MaxLevel,3)
	Real xx4(MaxLevel,3),xx5(MaxLevel,3),xx6(MaxLevel,3)

	Real x(Nlevel,15,3)  ! predictors in absorber space

        Real Dp(MaxLevel,3)! absorber within layer

	Real Kp(MaxLevel,Nchan,3) ! absorption coeff in pressure space
        Real Kw(Nw,Nchan,3)       ! absorption coeff in absorber space

	Real Od(MaxLevel,Nchan,3) ! Optical depth in pressure space

        Logical Find_Levels     ! switch: .True. ==> find levels for interpolation
                                !         .False.==> take from last call
        Integer MaxWlevels(3)   ! Actual number of levels used in W space
                                ! Not to be confused with MaxLevel above.
        Integer MaxWlevelsU(3)  ! Unique number of levels used in W space

        Integer Wlevels(Nw,3)   ! index array pointing to the W space
                                ! levels actually used
        Integer WlevelsU(Nw,3)  ! index array pointing to the W space
                                ! Unique levels actually used
	Integer BackLevels(Nw,3)! index array pointing to the P space
				! levels actually used
				! (length Nw for coefficient generation)

	Common /Opcom/ 
     &		 s1, s2, s3, s4, s5, s6,
     &		xx1,xx2,xx3,xx4,xx5,xx6,x,
     &		Dp,Kw,Kp,
     &		Od,
     &		Find_Levels,
     &		MaxWlevels,Wlevels,MaxWlevelsU,WlevelsU,BackLevels

*	End Include file opcom

