	implicit none
	include 'constants.inc'

	Real Bw(Nwet+1,Nw,Nchan)
	Real Bd(Ndry+1,Nw,Nchan)
	Real Bo(Nozo+1,Nw,Nchan)

	Integer i,j,k,Ichan

c        Open(12,file='tovs_noaa12_coeff.dat',
c     &		form='formatted',status='old')
        Open(12,file='tovs_noaa12_coeff.dat',
     &		form='formatted',status='old')
c        Open(42,file='noaa12_wet_coeff',
c     &          form='unformatted',status='unknown')
c        Open(43,file='noaa12_dry_coeff',
c     &          form='unformatted',status='unknown')
c        Open(44,file='noaa12_ozo_coeff',
c     &          form='unformatted',status='unknown')
       call assign('assign -a noaa12_wet_coeff 
     $  -s unblocked fort.42')
       call assign('assign -a noaa12_dry_coeff 
     $  -s unblocked fort.43')
       call assign('assign -a noaa12_ozo_coeff 
     $  -s unblocked fort.44')

	Do Ichan = 1 , Nchan
1200     Format(i4,6e20.12)
	 do i = 1 , Nw
	  Read(12,1200) k,(Bd(j,i,Ichan),j=1,Ndry+1)
	 EndDo
	 Do i = 1 , Nw
	  Read(12,1200) k,(Bw(j,i,Ichan),j=1,Nwet+1)
  	 EndDo
	 Do i = 1 , Nw
	  Read(12,1200) k,(Bo(j,i,Ichan),j=1,Nozo+1)
  	 EndDo

	EndDo

	Write(42) Bw
	Write(43) Bd
	Write(44) Bo

	Close(42)
	Close(43)
	Close(44)

	Stop
	end
