C          CPARAM.        PARAMETER STATEMENTS FOR RTATOV SUITE.
C                         VERSION 1.
C          J.R.EYRE       *ECMWF*        05/01/94.
C
	Integer jpsat,jpnsat,jplev,jplapf,jppf,jpnav,jpnsav,jpnssv,
     &		jpncv,jpch,jphir,jpmsu,jpssu,jpchus,jpchpf,jpcofm,
     &		jpcofw,jpcofo,jpst,jpmach,jpiset

      PARAMETER (JPSAT=10)       !   ! MAX NO. OF SATS COEFFS AVAILABLE ! TOVS
c      PARAMETER (JPSAT=1)       !   ! MAX NO. OF SATS COEFFS AVAILABLE ! ATOVS
      PARAMETER (JPNSAT=2)      !   ! MAX NO. OF SATS COEFFS STORED    ! TOVS
c      PARAMETER (JPNSAT=1)      !   ! MAX NO. OF SATS COEFFS STORED    ! ATOVS
      PARAMETER (JPLEV=40)          ! NO. OF PRESS LEVELS - TRANS CALC
      PARAMETER (JPLAPF=50)         ! NO. OF PRESS LEVELS - INPUT AND RT
      PARAMETER (JPPF=1)        !   ! MAX NO. PROFILES
      PARAMETER (JPNAV=4)           ! MAX NO. ATMOS PROFILE VARIABLES
      PARAMETER (JPNSAV=6)          ! MAX NO. SURFACE AIR VARIABLES
      PARAMETER (JPNSSV=6)          ! MAX NO. SURFACE SKIN VARIABLES
      PARAMETER (JPNCV=4)           ! MAX NO. CLOUD VARIABLES
      PARAMETER (JPCH=27)       !   ! MAX. NO. OF TOVS CHANNELS        ! TOVS
c      PARAMETER (JPCH=40)       !   ! MAX. NO. OF TOVS CHANNELS        ! ATOVS
      PARAMETER (JPHIR=20)          ! MAX. NO. OF HIRS CHANNELS
      PARAMETER (JPMSU=4)       !   ! MAX. NO. OF MSU CHANNELS         ! TOVS
c      PARAMETER (JPMSU=20)      !   ! MAX. NO. OF AMSU CHANNELS        ! ATOVS
      PARAMETER (JPSSU=3)       !   ! MAX. NO. OF SSU CHANNELS         ! TOVS
      PARAMETER (JPCHUS=23)     !   ! MAX. NO. OF CHANNELS USED        ! TOVS
c      PARAMETER (JPCHUS=38)     !   ! MAX. NO. OF CHANNELS USED        ! ATOVS
      PARAMETER (JPCHPF=JPPF*JPCHUS)  ! MAX NO. OF PROFS * CHANS USED
      PARAMETER (JPCOFM=14)         ! MIXED GAS COEFFS (MAX)
      PARAMETER (JPCOFW=14)         ! WATER VAPOUR COEFFS (MAX)
      PARAMETER (JPCOFO=4)          ! OZONE COEFFS
      PARAMETER (JPST=10)           ! MAX NO. OF SURFACE TYPES
      PARAMETER (JPMACH=1)      !   ! MACHINE: UNICOS=1, NOS/VE=0
      PARAMETER (JPISET=0)      !   ! INSTRUMENT SET: TOVS=0, ATOVS=1
c      PARAMETER (JPISET=1)      !   ! INSTRUMENT SET: TOVS=0, ATOVS=1
 
 
 
