C          /PRFVAR/  PROFILE VARIABLES
C          17/8/92.     VERSION 2 CHANGE: MOVE TO TASKCOMMON.
C          25/5/93.     CHANGES FOR RTATOV.
      COMMON/PRFVAR/prsr,TEMP,WMIX,OMIX,CLW,
     *SURFP,SURFW,TA,WMIXS,OMIXS,CLWS,
     *TS,EMSMW,EMSIR,
     *CLDF,CLDPT,CLDPB,CLDER,
     *pw,TOTO
CDIR$ TASKCOMMON PRFVAR
      REAL prsr(jplapf,jppf),TEMP(JPLAPF,JPPF),WMIX(JPLAPF,JPPF),
     *OMIX(JPLAPF,JPPF),CLW(JPLAPF,JPPF),
     *SURFP(JPPF),SURFW(JPPF),TA(JPPF),WMIXS(JPPF),
     *OMIXS(JPPF),CLWS(JPPF),
     *TS(JPPF),EMSMW(4,JPPF),EMSIR(JPPF),
     *CLDF(JPPF),CLDPT(JPPF),CLDPB(JPPF),CLDER(JPPF),
     *pw(jplapf,jppf),TOTO(jplapf,JPPF)
C          TEMP: TEMPERATURE PROFILE IN K
C          WMIX: SPECIFIC HUMIDITY PROFILE IN G/KG
C          OMIX: OZONE MIXING RATIO PROFILE IN KG/KG
C          CLW: CLOUD LIQUID WATER PROFILE IN KG/KG
C          SURFP: SURFACE PRESSURE IN MB=HPA
C          SURFW: SURFACE WIND SPEED IN M/S**2
C          TA: SURFACE AIR TEMPERATURE IN K
C          WMIXS: SURFACE SPECIFIC HUMIDITY IN G/KG
C          OMIXS: SURFACE OZONE MIXING RATIO IN KG/KG
C          CLWS: SURFACE CLOUD LIQUID WATER IN KG/KG
C          TS: SURFACE SKIN TEMPERATURE IN K
C          EMSMW: 4 MICROWAVE SURFACE EMISSIVITY PARAMETERS
C          EMSIR: 1 INFRA-RED SURFACE EMISSIVITY PARAMETER
C          CLDF: FRACTIONAL (IR) CLOUD COVER
C          CLDPT: CLOUD-TOP PRESSURE IN MB=HPA
C          CLDPB: CLOUD-BASE PRESSURE IN MB=HPA
C          CLDER: CLOUD DROP EFFECTIVE RADIUS IN M
C	   pw: precipitable water profile in cm
C          TOTO: TOTAL COLUMN OZONE profile in cm*10^xx
C
 
 
 
