CCC  hum_read.f -- read cloud cover data and compute mixing ratio
      real ccv(640,320,13)
      real es,ws,t

      kc=0
      read(5)ccv
      do i=1,640
       do j=1,320
         if(ccv(i,j,13).ge.0.2.and.ccv(i,j,13).le.0.8)then
           kc = kc + 1
           write(*,*)' CASE No: ', kc

           covmax = 0.
           covmin = 2.0
           do k=1,13
            if(ccv(i,j,k).gt.covmax)then 
               covmax=ccv(i,j,k)
            endif
            write(*,*)ccv(i,j,k)
           enddo
         endif
         write(*,*)covmax,nmax,nmin
         if(kc.gt.7)goto 315
       enddo
      enddo
c      write(6,290)(ccv(i,j),j=156,170)
c290   format(15i5)
315   continue

      temp = 293.
      para1 = 2.5e6/4.61e2
      para2 = 1./273.15
      write(*,*)' constant of exponetial ',para1
      write(*,*)' inversion of temperature ', para2
      p=980
      t=293.15
      es = 6.11*exp(2.50e6/4.61e2*(1./273.15-1./t))
      ws = 0.622*es/(p-es)
c      rh = 100. * 10./ws(es(293.15),980)
c      write(*,*)' saturated water vapor partial pressure ', es(293.15)
c      write(*,*)' saturated mixing ratio ', ws(es(293.15),980)
      rh = 100. * 0.01 /ws
      write(*,*)' saturated water vapor partial pressure ', es
      write(*,*)' saturated mixing ratio ', ws
      write(*,*)' relative humidity ', rh
      stop
      end
